package stack;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.Stack;
import java.util.regex.Pattern;

public class ReversePoland {

    private ArrayStack<Integer> numStack = new ArrayStack(10);

    private List<String> expressList = new ArrayList<>();

    public int calculate(String expression){
        translateExpress(expression);
        int length = expressList.size();
        String operRegex = "[+\\-*/]";
        Pattern operPattern = Pattern.compile(operRegex);
        for (int i = 0; i<length;i++){
            String str = expressList.get(i);
            if (operPattern.matcher(str).matches()) {
                if("+".equals(str)){
                    int num1 = numStack.pop();
                    int num2 = numStack.pop();
                    int result = num1 + num2;
                    numStack.push(result);
                }
                if("-".equals(str)){
                    int num1 = numStack.pop();
                    int num2 = numStack.pop();
                    int result = num2 - num1;
                    numStack.push(result);
                }
                if("*".equals(str)){
                    int num1 = numStack.pop();
                    int num2 = numStack.pop();
                    int result = num2 * num1;
                    numStack.push(result);
                }
                if("/".equals(str)){
                    int num1 = numStack.pop();
                    int num2 = numStack.pop();
                    int result = num2/num1;
                    numStack.push(result);
                }
            } else {
                numStack.push(Integer.parseInt(expressList.get(i)));
            }
        }

        return numStack.pop();
    }

    public void translateExpress(String expression){
        String[] strArr = expression.split(";");
        for (String str : strArr){
            expressList.add(str);
        }
    }

    public static void main(String[] args) {
        ReversePoland reversePoland = new ReversePoland();
        Scanner scan = new Scanner(System.in);
        while (true) {
            System.out.println("c计算, s查看, exit退出:");
            String handle = scan.next();
            if ("exit".equals(handle)){
                break;
            }
            if ("c".equals(handle)){
                System.out.println("请输入计算表达式:");
                String expression = scan.next();
                int calculate = reversePoland.calculate(expression);
                System.out.println("计算结果为:" + calculate);
            }
            if ("s".equals(handle)){

            }
        }
        scan.close();
    }
}
